/**
* File contains code needed to handle streams
* AS or right now 8/19/2007
* It contains an ugly table constructed from excel spread sheets with 
* stream urls. 
*
*
*/

//Static stream information for now
// Once there is a coherent plan on how to go about this 
// may be it will be part of the request
// 

/*
classid="CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95"
*var __asxtemplate=
'<OBJECT ID="AsxPlayer1" width=0 height=0 classid="CLSID:6BF52A52-394A-11D3-B153-00C04F79FAA6" \
codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902" \
standby="Loading Microsoft Windows Media Player components..." type="application/x-oleobject"  \
ENABLEJAVASCRIPT="true" > \
<PARAM NAME="FileName" VALUE="${stream_url}"> \
        <PARAM NAME="animationatStart" VALUE="true"> \
        <PARAM NAME="transparentatStart" VALUE="true"> \
        <PARAM NAME="autoStart" VALUE="true"> \
        <PARAM NAME="showControls" VALUE="true"> \
        <PARAM NAME="ShowTracker" VALUE="false"> \
        <param name="ShowStatusBar" value="true"> \
        <PARAM NAME="ShowDisplay" VALUE="false"> \
        <PARAM NAME="TransparentAtStart" VALUE="True"> \
        <PARAM NAME="autoSize" VALUE="true"> \
        <PARAM NAME="displaySize" VALUE="80"> \
        <PARAM NAME="uiMode" VALUE="dinvisible"> \
        <EMBED ID="AsxPlayer1" type = "application/x-mplayer2" \
				pluginspage = "http://www.microsoft.com/Windows/MediaPlayer/" \
				SRC="${stream_url}" \
				width="0" \
                height="0"  \
				AutoStart="true" \
				animationatStart="true" \
				transparentatStart="true" \
				showControls="0" \
				ShowTracker="0" \
				ShowStatusBar="1" \
				ShowDisplay="0" \
                autoSize="true" \
                uimode="dinvisible" \
                enablejavascript="true"  \
				displaySize="70" ></EMBED></OBJECT>';
                */

/**
*Some Sites list the class id as  the below.
* CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95
* According to http://www.w3schools.com/media/media_playerref.asp
* this is the clsid of the older com component and is still recognized but 
* has an older interface
*/
//Version 6.4:22D6F312-B0F6-11D0-94AB-0080C74C7E95
//version 7:6BF52A52-394A-11D3-B153-00C04F79FAA6
var __asxtemplate=
'<OBJECT ID="AsxPlayer1" width=0 height=0 \
classid="CLSID:22D6F312-B0F6-11D0-94AB-0080C74C7E95" \
codebase="http://activex.microsoft.com/activex/controls/mplayer/en/nsmp2inf.cab#Version=6,0,02,902" \
standby="Loading Microsoft Windows Media Player components..." type="application/x-oleobject"  \
ENABLEJAVASCRIPT="true" > \
<PARAM NAME="FileName" VALUE="${stream_url}"> \
        <PARAM NAME="animationatStart" VALUE="true"> \
        <PARAM NAME="transparentatStart" VALUE="true"> \
        <PARAM NAME="autoStart" VALUE="true"> \
        <PARAM NAME="showControls" VALUE="true"> \
        <PARAM NAME="ShowTracker" VALUE="true"> \
        <param name="ShowStatusBar" value="true"> \
        <PARAM NAME="ShowDisplay" VALUE="true"> \
        <PARAM NAME="TransparentAtStart" VALUE="True"> \
        <PARAM NAME="autoSize" VALUE="true"> \
        <PARAM NAME="displaySize" VALUE="80"> \
         <EMBED NAME="AsxPlayer1" ID="AsxPlayer1" type = "application/x-mplayer2" \
				pluginspage = "http://www.microsoft.com/Windows/MediaPlayer/" \
				SRC="${stream_url}" \
				width="0" \
                height="0"  \
				AutoStart="true" \
				animationatStart="true" \
				transparentatStart="true" \
				showControls="0" \
				ShowTracker="0" \
				ShowStatusBar="1" \
				ShowDisplay="0" \
                autoSize="true" \
                uimode="dinvisible" \
                enablejavascript="true"  \
                displaySize="70" ></EMBED>       </OBJECT>';

var __vlc_template='<embed type="application/x-vlc-plugin" \
        id="vlcPlayer1" name="vlcPlayer1" version="VideoLAN.VLCPlugin.2"\
         autoplay="no" loop="yes" hidden="true" \
         target="${stream_url}" />';
               
var RadioStreams = {
  ASX_REGEX: new RegExp("\.asx"),
    ASX_TEMPLATE:__asxtemplate,
    VLC_REGEX: new RegExp(".*"),
  VLC_TEMPLATE:__vlc_template
};

/**
  * Helper function to enable VLC
  * Just trash the Asx Regex
  */
RadioStreams.useVLC=function(){
    RadioStreams.ASX_REGEX=new RegExp("THIS CANT POSSIBLE BE A URL");
};

RadioStreams.getStreamRecord=function(sid,cid){
    var key=sid + "" + cid;
    return STREAMS_BY_STATION[key];
};

/**
* Get HTML FOR A STREAM
*/
RadioStreams.getStreamInfo=function(sdata,cdata)
{
    var sid=sdata.id;
    var cid=cdata.stationUID;
    
    var url=cdata.streamurl;
    if(!url) return "";
    DEBUG("STREAM URL IS " + url);
    if(RadioStreams.ASX_REGEX.test(url)){
	return { html: RadioStreams.getAsxStreamHTML(url),
		 handler: RadioStreams.getAsxHandler(),
		 streamurl: url
	       };
    }else if(RadioStreams.VLC_REGEX.test(url)){
	return {html: RadioStreams.getVlcStreamHTML(url),
		handler:RadioStreams.getVlcHandler(),
		streamurl: url
	       };
    }else{
	return  { html: "", handler:null, streamurl:url };
    }
}



function expandTemplate(body,vars){
    return   body.replace(/\$\{([A-z\-]+)\}/g,
			  function(mtch,nme){
			      return vars[nme];
			  });
}

RadioStreams.getAsxStreamHTML=function(url){
    return expandTemplate(RadioStreams.ASX_TEMPLATE,{ stream_url:url});
}

RadioStreams.getVlcStreamHTML=function(url){
    return expandTemplate(RadioStreams.VLC_TEMPLATE,{stream_url:url});
}

function AsxStreamHandler(){
    this.player=null;
    return this;
};

function tryThese(lst){
    for(var i=0;i<lst.length;++i){
	try{
	    DEBUG("TRYING " + lst[i]);
	    lst[i]();
	    break;
	}catch(e){
	    DEBUG(printEx(e));
	}
    }
}

/**
* Finalize the stream handler  
*/
AsxStreamHandler.prototype.finalize=function() {
    if(this.player){
	this.stop();//stop the player.
	//on IE we can somehow stop this stuff.
    }
}

/*
* New control was added so initialize
*/
AsxStreamHandler.prototype.init=function(){
    this.player=document.getElementById("AsxPlayer1");
    if(this.player){
	var handler=this;
	try{
	    this.player.onplaystatechanged=function(x){
		DEBUG("Play state changed to [" + x + "]");
            }
	}catch(e){
            DEBUG("Unable to Capture onplaystatechanged");
	}
	//  DEBUG("Got Asx Player:" + dumpObj(this.player));
	handler = null;
    }
}

AsxStreamHandler.prototype.state=function(){
    return "unknown";
}

AsxStreamHandler.prototype.play=function(){
    var player=this.player;
    if(this.player){
	tryThese([
	    function() {  player.controls.play();/*WMP7*/ },
	    function() { player.Play();/*WMP 6.4*/ },
	    function() { player.play(); } /*QTMoviePlayer*/]);
	if(player.controls){
	    DEBUG("Player has controls");
	}
    }
}

AsxStreamHandler.prototype.stop=function(){
    var player=this.player;
    if(this.player) tryThese([
        function() { player.controls.stop(); },
        function() { player.Stop(); },
        function() { player.stop(); }]);
    player = null;
}

AsxStreamHandler.prototype.pause=function(){
    var player=this.player;
    if(this.player) tryThese([
        function(){ player.controls.pause(); },
        function(){ player.Pause(); },
        function() { player.pause(); } ]);
    player = null;
}

/**
* Getter or setter for volume
*/
AsxStreamHandler.prototype.volume=function(mode,x){
    var player=this.player;
    var ret=0;
    if(mode == "set"){
        tryThese([
            function(){player.controls.volume= x;/*WMP7+*/ },
            function(){player.volume = x;/*SAFARI*/ }
        ]);
    }else{
        tryThese([
            function() {ret=player.controls.volume; },
            function(){x=player.volume; } 
        ]);
	
    }
    player = null;
    return ret;
}

AsxStreamHandler.prototype.onEvent=function(type,a1,a2,a3){
    DEBUG("GOT ASX EVENT:" + type + "," + a1+ "," + a2);
}

RadioStreams.getAsxHandler=function(x){
    return new AsxStreamHandler();
};

//VLC STREAM HANDLER
function VlcStreamHandler(){
    this.player=null;
    this.calls=null;
    return this;
}

VlcStreamHandler.prototype.finalize=function(){
    if(this.player)this.stop();
}

/**
  * Initialized stream handler
  */
VlcStreamHandler.prototype.init=function(){
    this.player=document.getElementById("vlcPlayer1");
    if(this.player){
	//if there is  play we are using the pre 0.8.5 plugin with the simplified object model
	try{
            this.calls=vlcPost085Calls;
            return this.play();
	}catch(e){
            return false;
	}
    }
    return false;
}

//Implementation of VLC API pre 0.8.5
//
/*NOT REALLY SUPPORTED
  var vlcPre085Calls={
    play:function(x){
      x.play();
    },
    stop:function(x){
      x.stop();
    },
    pause:function(x){
      x.pause();
    },
    is_playing:function(x){
      return x.isplaying();
    },
    stream_state:function(){
      return "unknown";
    }
    };*/

//Post 0.8.5 vlc api
var vlcPost085Calls={
    play:function(x){
        x.playlist.play();
    },
    stop:function(x){
        x.playlist.stop();
    },
    pause:function(x){
        x.playlist.togglePause();
    },
    is_playing:function(x){
        return x.playlist.isPlaying();
    },
    stream_state:function(x){
        switch( x.input.state)
        {
        case 0: 
            return "stopped";
        case 1:
            return "loading";
        case 2: 
            return "buffering";
        case 3:
            return "playing";
        case 4:
            return "paused";
        case 5:
            return "stopped";
        case 6:
            return "error";
        }
	
    }
};

VlcStreamHandler.prototype.play=function(){
    var p = this;
    var failed=false;
    if(p.player){
	tryThese([function(){
            p.calls.play(p.player);},
		  function(){failed=true;}
		 ]);
    }
    p = null;
    return !failed;
};

/**
  * Get stream state 
  */
VlcStreamHandler.prototype.state=function(){
    var p=this;
    var ret;
    if(p.player){
	tryThese([function(){
            ret=p.calls.stream_state(p.player);
	}]);
    }
    p = null;
    return ret || "unknown";
};


VlcStreamHandler.prototype.pause=function(){
    var p = this;
    if(p.player){
	tryThese([function(){
            p.calls.pause(p.player);}]);
    }
    p = null;
};

VlcStreamHandler.prototype.stop=function(){
    var p = this;
    if(p.player){
	tryThese([function(){
            p.calls.stop(p.player);}]);
    }
    p = null;
};

VlcStreamHandler.prototype.is_playing=function(){
    var p = this.player;
    if(p){
	tryThese([function(){
            p.calls.is_playing(p.player);}]);
    }
    p = null;
};

RadioStreams.getVlcHandler=function(x){
    return new VlcStreamHandler();
};


